----------------------------------------------------------------------------------
-- www.posedge.ir
-- Mohsen Sadeghi Moghaddam
-- DFF (with CASE)
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;


entity my_hw is

		PORT (d, clk, rst: IN BIT;
				q: OUT BIT);

end my_hw;

architecture Behavioral of my_hw is

begin

	PROCESS (clk, rst)
	BEGIN
		CASE rst IS
		
			 WHEN '1' =>
			 q<='0';
			 
			 WHEN '0' =>
				IF (clk'EVENT AND clk='1') THEN
				q <= d;
				END IF;
				
			 WHEN OTHERS => NULL; -- Unnecessary, rst is of type BIT
			 
		 END CASE;
		 END PROCESS;
end Behavioral;

