----------------------------------------------------------------------------------
-- www.posedge.ir
-- Mohsen Sadeghi Moghaddam
-- Leading Zeros
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity example is

	PORT (  data	: IN   STD_LOGIC_VECTOR (7 DOWNTO 0);
			zeros	: OUT  INTEGER RANGE 0 TO 8			);

end example;

----   00011101  ===> out : 3  ------------------
----   00000101  ===> out : 5  ------------------

architecture Behavioral of example is		
begin

	PROCESS (data)
		 VARIABLE count: INTEGER RANGE 0 TO 8;
	BEGIN
		 count := 0;
		 
		 FOR i IN data'RANGE LOOP	-- ANOTHER WAY  =====>>>>   for i in 0 to 7 loop
			CASE data(i) IS
				WHEN '0' => count := count + 1;
				WHEN OTHERS => EXIT;
			END CASE;
		 END LOOP;
		 
		 zeros <= count;
		 
	 END PROCESS;
		


end Behavioral;

